#include  <windows.h>
//#define   _UNICODE
#include  <tchar.h>
#include  <stdio.h>
#include  <string.h>
#include  <process.h>
#include  <sql.h>                        //ODBC header file
#include  <sqlext.h>                     //ODBC header file
#include  "WinTypes.h"
#include  "SqlProcs.h"
#include  "Strings.h"
#include  "Sql.h"
#include  "Main.h"
#include  "Excel.h"
#include  "Access.h"

#if defined(MY_DEBUG)
    extern   FILE* fp;
#endif


int GetExcelRecordCount(SQL& Sql, unsigned int& iLine)
{
 unsigned int iRecCt=0;
 TCHAR szQuery[128];
 SQLHSTMT hStmt;
 long iJnk;

 _tcscpy(szQuery,_T("SELECT Count(*)  As RecordCount From [Sheet1$];"));
 SQLAllocHandle(SQL_HANDLE_STMT,Sql.hConn,&hStmt);
 SQLBindCol(hStmt,1,SQL_C_ULONG,&iRecCt,0,&iJnk);
 if(SQLExecDirect(hStmt,(SQLTCHAR*)szQuery,SQL_NTS)!=SQL_SUCCESS)
 {
    SQLGetDiagRec(SQL_HANDLE_STMT,hStmt,1,Sql.szErrCode,&Sql.iNativeErrPtr,Sql.szErrMsg,512,&Sql.iTextLenPtr);                                                          
    SQLFreeHandle(SQL_HANDLE_STMT,hStmt);
    return -1;
 }
 else
 {
    SQLFetch(hStmt);
    SQLCloseCursor(hStmt);
    SQLFreeHandle(SQL_HANDLE_STMT,hStmt);
    return iRecCt;
 }
}


UINT blnDumpExcelData(SQL& sql, TCHAR** ptrLines, unsigned int& iLine, HWND hWnd)
{
 SQLHSTMT          hStmt;
 TCHAR             szQuery[100];
 TCHAR             szDate[16];
 SQLINTEGER        iJnk;
 UINT              iId;
 double            dblNum;
 TIMESTAMP_STRUCT  ts;
 SQLTCHAR          szString[64];
 TCHAR             szBuffer[128];

 if(SQLAllocHandle(SQL_HANDLE_STMT,sql.hConn,&hStmt)==SQL_SUCCESS)
 {
    _tcscpy(szQuery,_T("SELECT Id, Float_Point, Date_Field, Text_Field FROM [Sheet1$];"));
    SQLBindCol(hStmt,1,SQL_C_ULONG,&iId,0,&iJnk);
    SQLBindCol(hStmt,2,SQL_C_DOUBLE,&dblNum,0,&iJnk);
    SQLBindCol(hStmt,3,SQL_C_TYPE_DATE,&ts,0,&iJnk);
    SQLBindCol(hStmt,4,SQL_C_TCHAR,szString,64,&iJnk);
    iLine++;

    //Allocate Heading
    ptrLines[iLine]=(TCHAR*)GlobalAlloc(GPTR,48*sizeof(TCHAR));
    if(!ptrLines[iLine])
    {
       MessageBox(hWnd,_T("Memory Allocation Error!"),_T("Not Good!"),MB_ICONERROR);
       ErrorMemFree(ptrLines,iLine);
       sql.ODBCDisconnect();
       return FALSE;
    }
    _tcscpy(ptrLines[iLine],_T("iId      Double           Date           String"));
    iLine++;

    //Allocate Equal ( = ) Sign String Seperator
    ptrLines[iLine]=(TCHAR*)GlobalAlloc(GPTR,55*sizeof(TCHAR));
    if(!ptrLines[iLine])
    {
       MessageBox(hWnd,_T("Memory Allocation Error!"),_T("Not Good!"),MB_ICONERROR);
       ErrorMemFree(ptrLines,iLine);
       sql.ODBCDisconnect();
       return FALSE;
    }
    _tcscpy(ptrLines[iLine],_T("======================================================"));
    iLine++;

    if(SQLExecDirect(hStmt,(SQLTCHAR*)szQuery,SQL_NTS)==SQL_SUCCESS)
    {
       while(SQLFetch(hStmt)!=SQL_NO_DATA)
       {
        MkDate(ts,szDate);
        memset(szBuffer,0,128);
        _stprintf(szBuffer,_T("%-6u%8.2f           %-12.10s  %-20s"),iId,dblNum,szDate,szString);
        ptrLines[iLine]=(TCHAR*)GlobalAlloc(GPTR,(_tcslen(szBuffer)+1)*sizeof(TCHAR));
        if(!ptrLines[iLine])
        {
           MessageBox(hWnd,_T("Memory Allocation Error!"),_T("Not Good!"),MB_ICONERROR);
           ErrorMemFree(ptrLines,iLine);
           sql.ODBCDisconnect();
           return FALSE;
        }
        _tcscpy(ptrLines[iLine],szBuffer);
        iLine++;
       }
    }
    SQLCloseCursor(hStmt);
    SQLFreeHandle(SQL_HANDLE_STMT,hStmt);
    return TRUE;
 }

 return FALSE;
}


void ExcelThread(void* pVoid)
{
 unsigned int iLine=0,iScreenLinesNeeded=10;
 HWND hMainWnd,hOutput;
 TCHAR** ptrLines=NULL;
 TCHAR lpBuffer[512];
 DWORD nBufLen=512;
 int iRecCt=0;
 String s1;
 SQL Sql;

 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("Entering ExcelThread()\n"));
 #endif
 hOutput=FindWindowEx(0,0,_T("frmOutput"),_T("Data Dump Of Excel Spreadsheet With ODBC"));
 hMainWnd=FindWindowEx(0,0,TEXT("SqlDemo"),TEXT("ODBC Demo"));
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("  hMainWnd   = %u\n"),hMainWnd);
     _ftprintf(fp,_T("  hOutput    = %u\n"),hOutput);
 #endif
 Sql.strDriver=_T("Microsoft Excel Driver (*.xls)");
 GetCurrentDirectory(nBufLen,lpBuffer);
 Sql.strDBQ = lpBuffer;
 Sql.strDBQ = Sql.strDBQ +_T("\\") + _T("Book1.xls");
 Sql.ODBCConnect();
 if(Sql.blnConnected==TRUE)
 {
    #if defined(MY_DEBUG)
        _ftprintf(fp,_T("  Sql.blnConnected=TRUE\n"));
    #endif
    iRecCt=GetExcelRecordCount(Sql,iLine);
    iScreenLinesNeeded=iScreenLinesNeeded+iRecCt+5;
    ptrLines=(TCHAR**)GlobalAlloc(GPTR,iScreenLinesNeeded*sizeof(TCHAR*));
    if(!ptrLines)
    {
       MessageBox(hMainWnd,_T("Memory Allocation Error!"),_T("Not Good!"),MB_ICONERROR);
       Sql.ODBCDisconnect();
       return;
    }
    SetWindowLong(hOutput,0,iScreenLinesNeeded);
    SetWindowLong(hOutput,4,(long)ptrLines);

    //Make First Output Line For frmOutput
    ptrLines[0]=(TCHAR*)GlobalAlloc(GPTR,(_tcslen(lpBuffer)+1)*sizeof(TCHAR));
    if(!ptrLines[0])
    {
       MessageBox(hMainWnd,_T("Memory Allocation Error!"),_T("Not Good!"),MB_ICONERROR);
       ErrorMemFree(ptrLines,iLine);
       Sql.ODBCDisconnect();
       return;
    }
    _tcscpy(ptrLines[0],lpBuffer);
    iLine++;

    //Make Second Output Line For frmOutput
    ptrLines[1]=(TCHAR*)GlobalAlloc(GPTR,(_tcslen(Sql.strConnectionString.lpStr())+1)*sizeof(TCHAR));
    //ptrLines[1]=(TCHAR*)GlobalAlloc(GPTR,(_tcslen(Sql.szCnIn)+1)*sizeof(TCHAR));
    if(!ptrLines[1])
    {
       MessageBox(hMainWnd,_T("Memory Allocation Error!"),_T("Not Good!"),MB_ICONERROR);
       ErrorMemFree(ptrLines,iLine);
       Sql.ODBCDisconnect();
       return;
    }
    //_tcscpy(ptrLines[1],Sql.szCnIn);
    _tcscpy(ptrLines[1],Sql.strConnectionString.lpStr());
    iLine++;

    //Make Third Output Line For frmOutput
    ptrLines[2]=(TCHAR*)GlobalAlloc(GPTR,27*sizeof(TCHAR));
    if(!ptrLines[2])
    {
       MessageBox(hMainWnd,_T("Memory Allocation Error!"),_T("Not Good!"),MB_ICONERROR);
       ErrorMemFree(ptrLines,iLine);
       Sql.ODBCDisconnect();
       return;
    }
    _tcscpy(ptrLines[2],_T("ODBC Connection Succeeded!"));
    iLine++;
    if(iRecCt>0)
       blnDumpExcelData(Sql,ptrLines,iLine,hMainWnd);
    Sql.ODBCDisconnect();
 }
 else
 {
    #if defined(MY_DEBUG)
        _ftprintf(fp,_T("  Sql.blnConnected=FALSE\n"));
    #endif
 }
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("Leaving ExcelThread()\n"));
 #endif
}


void btnExcel_OnClick(lpWndEventArgs Wea)
{
 unsigned long hThread;
 HCURSOR hCursor;
 TCHAR szVar[48];
 HINSTANCE hIns;
 HWND hOutput;

 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("Entering btnExcel_OnClick()\n"));
 #endif
 hCursor=LoadCursor(NULL,IDC_WAIT);
 SetClassLong(Wea->hWnd,GCL_HCURSOR,(LONG)hCursor);
 hIns=GetModuleHandle(NULL);
 _tcscpy(szVar,_T("Data Dump Of Excel Spreadsheet With ODBC"));
 hOutput=CreateWindow(_T("frmOutput"),szVar,WS_OVERLAPPEDWINDOW,200,500,725,275,0,0,hIns,0);
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("  hMainWnd   = %u\n"),Wea->hWnd);
     _ftprintf(fp,_T("  hOutput    = %u\n"),hOutput);
 #endif
 hThread=_beginthread(ExcelThread,0,0);
 WaitForSingleObject((HANDLE)hThread,INFINITE);
 ShowWindow(hOutput,SW_SHOWNORMAL);
 hCursor=LoadCursor(NULL,IDC_ARROW);
 SetClassLong(Wea->hWnd,GCL_HCURSOR,(LONG)hCursor);
 SetCursor(hCursor);
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("Leaving btnExcel_OnClick()\n\n"));
 #endif
}
