//SqlServer.cpp
#include   <windows.h>
//#define    _UNICODE
#include   <tchar.h>
#include   <shlobj.h>
#include   <stdio.h>
#include   <string.h>
#include   <process.h>
#include   <sql.h>                        //ODBC header file
#include   <sqlext.h>                     //ODBC header file
#include   "Main.h"
#include   "WinTypes.h"
#include   "SqlProcs.h"
#include   "Strings.h"
#include   "Sql.h"
#include   "SqlServer.h"
#include   "Access.h"
#if defined(MY_DEBUG)
    extern FILE* fp;
#endif


long blnCreateSqlServerExpressDB(SQL& Sql, TCHAR* szDBName)
{
 TCHAR lpBuffer[MAX_PATH];
 DWORD nBufLen=MAX_PATH;
 SQLHSTMT hStmt;
 String s1,s2;

 // C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\   << Path To SQL Server Express On My HP Laptop
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("  Entering blnCreateSqlServerExpressDatabase()\n"));
 #endif
 GetCurrentDirectory(nBufLen,lpBuffer);
 s1=lpBuffer;
 s1=s1+_T("\\");
 s2 = _T("CREATE DATABASE ");
 s2 = s2 + szDBName + _T(" ON (NAME=") + _T("'") + szDBName + _T("',");
 s2 = s2 + _T("FILENAME=") + _T("'") + s1 + szDBName + _T(".mdf',SIZE=10,MAXSIZE=50,FILEGROWTH=5) LOG ON (NAME='");
 s2 = s2 + szDBName + _T("Log',FILENAME='") + s1 + szDBName + _T(".ldf',SIZE=5,MAXSIZE=25,FILEGROWTH=5MB);");
 SQLAllocHandle(SQL_HANDLE_STMT,Sql.hConn,&hStmt);
 if(SQLExecDirect(hStmt,(SQLTCHAR*)s2.lpStr(),SQL_NTS)==SQL_ERROR)
 {
    #if defined(MY_DEBUG)
        _ftprintf(fp,_T("  SQLExecuteDirect() Failed On Database Creation!\n"));
    #endif
    SQLGetDiagRec(SQL_HANDLE_STMT,hStmt,1,Sql.szErrCode,&Sql.iNativeErrPtr,Sql.szErrMsg,512,&Sql.iTextLenPtr);
    #if defined(MY_DEBUG)
        _ftprintf(fp,_T("  Sql.szErrCode     = %s\n"),Sql.szErrCode);
        _ftprintf(fp,_T("  Sql.szErrMsg      = %s\n"),Sql.szErrMsg);
	       _ftprintf(fp,_T("  Sql.iNativeErrPtr = %d\n"),Sql.iNativeErrPtr);
    #endif
    SQLFreeHandle(SQL_HANDLE_STMT,hStmt);
    #if defined(MY_DEBUG)
        _ftprintf(fp,_T("  Leaving blnCreateSqlServerExpressDatabase()\n\n"));
    #endif
    return(Sql.iNativeErrPtr);
	}
 else
 {
    SQLFreeHandle(SQL_HANDLE_STMT,hStmt);
    #if defined(MY_DEBUG)
        _ftprintf(fp,_T("  Leaving blnCreateSqlServerExpressDatabase()\n\n"));
    #endif
    return(TRUE);
 }
}


long blnCreateSqlServerTable(SQL& Sql)
{
 TCHAR szQuery[256];
 SQLHSTMT hStmt;

 #if defined(MY_DEBUG)
    _ftprintf(fp,_T("  Entering blnCreateSqlServerTable()\n\n"));
 #endif
 _tcscpy(szQuery,_T("CREATE TABLE Table1 (Id int  NOT NULL, Float_Point float NULL, Date_Field smalldatetime NULL, Text_Field nvarchar(32) NULL);"));
 SQLAllocHandle(SQL_HANDLE_STMT,Sql.hConn,&hStmt);
 if(SQLExecDirect(hStmt,(SQLTCHAR*)szQuery,SQL_NTS)==0)
 {
    SQLFreeHandle(SQL_HANDLE_STMT,hStmt);
    #if defined(MY_DEBUG)
        _ftprintf(fp,_T("  Leaving blnCreateSqlServerTable()\n\n"));
    #endif
    return(TRUE);
 }
 else
 {
    SQLGetDiagRec(SQL_HANDLE_STMT,hStmt,1,Sql.szErrCode,&Sql.iNativeErrPtr,Sql.szErrMsg,512,&Sql.iTextLenPtr);
    #if defined(MY_DEBUG)
        _ftprintf(fp,_T("  Sql.szErrCode = %s\n"),Sql.szErrCode);
        _ftprintf(fp,_T("  Sql.szErrMsg  = %s\n"),Sql.szErrMsg);
    #endif
    SQLFreeHandle(SQL_HANDLE_STMT,hStmt);
    #if defined(MY_DEBUG)
        _ftprintf(fp,_T("  Leaving blnCreateSqlServerTable()\n\n"));
    #endif
    return(FALSE);
 }
}


void SqlServerThread(void* pVoid)
{
 unsigned int iLine=0,iScreenLinesNeeded=30;
 int iRecCt=0,iReturn=0;
 HWND hMainWnd,hOutput;
 TCHAR** ptrLines=NULL;
 TCHAR szOutput[512];
 TCHAR szBuffer[512];
 TCHAR lpBuffer[512];
 DWORD nSize=512;
 String s1;
 SQL Sql;

 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("Entering SqlServerThread()\n"));
 #endif
 hOutput=FindWindowEx(0,0,_T("frmOutput"),_T("ODBC Demo With Sql Server"));
 hMainWnd=FindWindowEx(0,0,TEXT("SqlDemo"),TEXT("ODBC Demo"));
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("  hMainWnd   = %u\n"),hMainWnd);
     _ftprintf(fp,_T("  hOutput    = %u\n"),hOutput);
 #endif
 Sql.strDriver=_T("SQL Server");

 ////For SQL Server Express
 //GetComputerName(lpBuffer,&nSize);                     //If you want this
 //Sql.strServer=lpBuffer;                               //to work for MSDE
 //Sql.strServer = Sql.strServer + _T("\\SQLEXPRESS");   //then REM these 3
 ////End For SQL Server Express                          //lines out.

 //For MSDE                                            //For MSDE just use
 Sql.strServer=_T("localhost");                      //"localhost" for SERVER
 //End MSDE

 Sql.ODBCConnect();   //To connect to SQL Server without connecting to any particular database, all you
 if(Sql.blnConnected) //need is "SQL Server" for the DRIVER= attribute, and YourComputerName\SQLEXPRESS
 {                    //for the SERVER= attribute.
    iReturn=blnCreateSqlServerExpressDB(Sql,_T("TestData"));
    #if defined(MY_DEBUG)
        _ftprintf(fp,_T("  iReturn(blnCreateSQLServerExpressDB()) = %d\n"),iReturn);
    #endif
    switch(iReturn)
	   {
	    case 1:   //If blnCreateSQLServerExpressDB() returns 1, the database was successfully created
       {
          iScreenLinesNeeded=25;
          SetWindowLong(hOutput,0,iScreenLinesNeeded);
          ptrLines=(TCHAR**)GlobalAlloc(GPTR,iScreenLinesNeeded*sizeof(TCHAR*));
          SetWindowLong(hOutput,4,(long)ptrLines);
          _stprintf(szOutput,_T("Sql.strDriver            = %s"),Sql.strDriver.lpStr());
          if(blnLineFailed(hMainWnd,Sql,ptrLines,iLine,szOutput))
             return;
          _stprintf(szOutput,_T("Sql.strServer            = %s"),Sql.strServer.lpStr());
          if(blnLineFailed(hMainWnd,Sql,ptrLines,iLine,szOutput))
             return;
          _stprintf(szOutput,_T("Sql.strConnectionString  = %s"),Sql.strConnectionString.lpStr());
          if(blnLineFailed(hMainWnd,Sql,ptrLines,iLine,szOutput))
             return;
          Sql.ODBCDisconnect();
          iReturn=GetCurrentDirectory(512,szBuffer);
          _stprintf(szOutput,_T("Current Directory = %s"),szBuffer);
          if(blnLineFailed(hMainWnd,Sql,ptrLines,iLine,szOutput))
             return;
          Sql.strDBQ=szBuffer;
          Sql.strDBQ = Sql.strDBQ +_T("\\") + _T("TestData.mdf");
          Sql.strDatabase = _T("TestData");
          Sql.ODBCConnect();
          if(Sql.blnConnected)
          {
             if(blnCreateSqlServerTable(Sql))
             {
                iRecCt++;
                if(blnInsert(Sql,ptrLines,iLine,hMainWnd,iRecCt))
                {
                   iLine++;
                   if(blnLineFailed(hMainWnd,Sql,ptrLines,iLine,_T("blnInsert() Succeeded!")))
                      return;
                }
                else
                {
                   iLine++;
                   if(blnLineFailed(hMainWnd,Sql,ptrLines,iLine,_T("blnInsert() Failed!")))
                      return;
                }
                iLine++;
                blnDumpData(Sql,ptrLines,iLine,hMainWnd);
             }
             Sql.ODBCDisconnect();
          }
          break;
       }
	    case 1801:    //database already exists, so we just will add some more data to it.  If
	      {           //TestData already exists, the Sql.dr.iNativeErrPtr return is 1801.
          Sql.ODBCDisconnect();
          iReturn=GetCurrentDirectory(512,szBuffer);
          Sql.strDBQ=szBuffer;
          Sql.strDBQ = Sql.strDBQ + _T("\\TestData.mdf");
          Sql.strDatabase = _T("TestData");
          Sql.ODBCConnect();
          if(Sql.blnConnected)
          {
             iRecCt=GetRecordCount(Sql,iLine);
             #if defined(MY_DEBUG)
                 _ftprintf(fp,_T("  iRecCt = %u\n"),iRecCt);
             #endif
             if(iRecCt!=-1)
             {
                iScreenLinesNeeded=25+iRecCt;
                SetWindowLong(hOutput,0,iScreenLinesNeeded);
                ptrLines=(TCHAR**)GlobalAlloc(GPTR,iScreenLinesNeeded*sizeof(TCHAR*));
                SetWindowLong(hOutput,4,(long)ptrLines);
                if(blnLineFailed(hMainWnd,Sql,ptrLines,iLine,_T("Failed To Create SQL Server Database!")))
                   return;
                if(blnLineFailed(hMainWnd,Sql,ptrLines,iLine,_T("TestData Already Exists In Sql Server!")))
                   return;
                _stprintf(szOutput,_T("Sql.strDriver           = %s"),Sql.strDriver.lpStr());
                if(blnLineFailed(hMainWnd,Sql,ptrLines,iLine,szOutput))                      //output cn.szDriver
                   return;
                _stprintf(szOutput,_T("Sql.strServer           = %s"),Sql.strServer.lpStr());
                if(blnLineFailed(hMainWnd,Sql,ptrLines,iLine,szOutput))                      //output cn.szServer
                   return;
                _stprintf(szOutput,_T("Sql.strConnectionString = %s"),Sql.strConnectionString.lpStr());
                if(blnLineFailed(hMainWnd,Sql,ptrLines,iLine,szOutput))                   //output Sql.szCnIn
                   return;
                iRecCt++;
                if(blnInsert(Sql,ptrLines,iLine,hMainWnd,iRecCt))
                {
                   iLine++;
                   if(blnLineFailed(hMainWnd,Sql,ptrLines,iLine,_T("blnInsert() Succeeded!")))
                      return;
                }
                else
                {
                   iLine++;
                   if(blnLineFailed(hMainWnd,Sql,ptrLines,iLine,_T("blnInsert() Failed!")))
                      return;
                }
             }
             iLine++;
             blnDumpData(Sql,ptrLines,iLine,hMainWnd);
             Sql.ODBCDisconnect();
           }
          break;
	      }
	    case 5133:       //Can't create database here!!!!!!!!!!!!!!!!!!!!  It doesn't appear that SQL Server
       {              //is willing to create databases just anywhere.  It flat out refuses to create any
          MessageBox  //for example under the Documents And Settings folder.  That includes your My Documents,
	         (           //Desktop, etc.  The same also appears to be true about Program Files, except for
		         hMainWnd,  //the Sql Server installation folder.
		         _T("There is a problem.  You may be trying to run SqlDemo from a directory ")
           _T("where Windows Won't allow databases to be created.  Documents and Settings ")
		         _T("and Program Files Are two such places.  Try putting SqlDemo.exe into some.")
		         _T("folder which isn't one of Windows 'Special' folders."),
		         _T("Couldn't Open Or Create Database.  It May Not Exist!"), MB_ICONERROR
		        );
          break;
       }
     default:
       {
          MessageBox
	         (
		         hMainWnd,
		         _T("There is a problem.  An unknown error for which this application can provide no further")
           _T("resolution has occurred.  I'm very sorry about it.  My programs are like that, unfortunately."),
           _T("Unspecified Error (The Worst Kind)"),
		         MB_ICONERROR
		        );
       }
    }
    Sql.ODBCDisconnect();
 }
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("Leaving SqlServerThread()\n\n"));
 #endif
}


void btnSqlServerExpress_OnClick(lpWndEventArgs Wea)
{
 HCURSOR hHourGlass,hArrow;
 unsigned long hThread;
 TCHAR szVar[32];
 HWND hOutput;

 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("Entering btnSqlServerExpress_OnClick()\n"));
     _ftprintf(fp,_T("  GetTickCount() = %u\n"),GetTickCount());
 #endif
 hHourGlass=LoadCursor(NULL,IDC_WAIT);
 SetClassLong(Wea->hWnd, GCL_HCURSOR, (LONG) hHourGlass);
 SetCursor(hHourGlass);
 EnableWindow(GetDlgItem(Wea->hWnd,IDC_SQL_SERVER_EXPRESS),FALSE);
 _tcscpy(szVar,_T("ODBC Demo With Sql Server"));
 hOutput=CreateWindow(_T("frmOutput"),szVar,WS_OVERLAPPEDWINDOW|WS_VSCROLL,200,500,775,275,0,0,GetModuleHandle(NULL),Wea->hWnd);
 hThread=_beginthread(SqlServerThread,0,0);
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("  hThread = %u\n"),hThread);
 #endif
 WaitForSingleObject((HANDLE)hThread,INFINITE);
 ShowWindow(hOutput,SW_SHOWNORMAL);
 EnableWindow(GetDlgItem(Wea->hWnd,IDC_SQL_SERVER_EXPRESS),TRUE);
 hArrow=LoadCursor(NULL,IDC_ARROW);
 SetClassLong(Wea->hWnd, GCL_HCURSOR, (LONG) hArrow);
 SetCursor(hArrow);
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("  GetTickCount() = %u\n"),GetTickCount());
     _ftprintf(fp,_T("Leaving btnSqlServerExpress_OnClick()\n\n"));
 #endif
}
