//frmOutput.cpp                  //This file contains code to display the Sql Drivers and database
#include  <windows.h>            //data created in SqlDrivers.cpp, Excel.cpp, Access.cpp, and
//#define   _UNICODE
#include  <tchar.h>              //SqlServer.cpp.  Back in fnWndProc_OnCreate() in Main.cpp the
#include  <stdio.h>              //Window Class frmOutput (say Form Output or Output Form or
#include  "Main.h"               //Window) was RegisterClassEx()'ed with the .cbWndExtra bytes set
#include  "WinTypes.h"           //to 16.  You can see below in frmOutput_OnCreate() what is stored
#include  "frmOutput.h"          //there.  Basically, all that information is 'state' data that needs
#if defined(MY_DEBUG)            //to persist across function calls/Windows messages to allow for
    extern FILE* fp;             //the proper scrolling functionality of the output display window.
#endif
extern EVENTHANDLER  frmOutputHdlr[5];


long frmOutput_OnCreate(lpWndEventArgs Wea)              //Offset    What's Stored There
{                                                        //================================
 HFONT hFont,hTmp;                                       //0  -  3   iLineCount
 TEXTMETRIC tm;                                          //4  -  7   ptrPtrBuffer
 HDC hDC;                                                //8  -  11  cyChar
                                                         //12 -  15  si.nPos, i.e., iStart
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("  Entering frmOutput_OnCreate()\n"));
 #endif
 hDC=GetDC(Wea->hWnd);
 hFont=CreateFont(16,0,0,0,FW_BOLD,0,0,0,0,0,0,2,0,_T("Courier New"));  //For tabular data you need
 hTmp=(HFONT)SelectObject(hDC,hFont);                                   //a fixed pitch font, and the
 GetTextMetrics(hDC,&tm);                                               //size of a char in this font
 SetWindowLong(Wea->hWnd,8,(long)tm.tmHeight);                          //is information you have to
 DeleteObject(SelectObject(hDC,hTmp));                                  //have to set up scrolling.
 ReleaseDC(Wea->hWnd,hDC);                                              //Another piece of information
 SetWindowLong(Wea->hWnd,12,0);                                         //that has to persist is the
 #if defined(MY_DEBUG)                                                  //scrolling position of the
     _ftprintf(fp,_T("  Leaving frmOutput_OnCreate()\n"));              //window.  Here its initially
 #endif                                                                 //set to zero and stored in the
                                                                        //.cbWndExtra bytes at offset 12.
 return 0;
}


long frmOutput_OnSize(lpWndEventArgs Wea)
{
 int iLinesVisible,iLineCount;
 unsigned int cyChar;
 SCROLLINFO si;

 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("\n\n  Entering frmOutput_OnSize()\n"));
 #endif
 iLineCount=(unsigned int)GetWindowLong(Wea->hWnd,0);
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("    iLineCount = %u\n"),iLineCount);
 #endif
 ZeroMemory(&si, sizeof(SCROLLINFO));
 si.cbSize =sizeof(SCROLLINFO);
 si.fMask = SIF_POS | SIF_RANGE;
 GetScrollInfo(Wea->hWnd,SB_VERT,&si);                //When a WM_SIZE message comes through, the
 cyChar=(unsigned int)GetWindowLong(Wea->hWnd,8);     //HIWORD(lParam) contains the client height
 iLinesVisible=HIWORD(Wea->lParam)/cyChar;            //of the Window in pixels.  This, in conjunc-
 si.cbSize = sizeof(SCROLLINFO);                      //tion with the cyChar info stored in the
 si.fMask =   SIF_POS | SIF_RANGE;                    //.cbWndExtra bytes, can be used to determine
 si.nMin = 0;                                         //the number of lines visible in the window.
 si.nMax = iLineCount-iLinesVisible;
 si.nPos=GetWindowLong(Wea->hWnd,12);
 if(si.nMax<0)
    si.nMax=0;
 SetScrollInfo(Wea->hWnd,SB_VERT,&si,TRUE);
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("  Leaving frmOutput_OnSize()\n\n"));
 #endif

 return 0;
}


long frmOutput_OnVScroll(lpWndEventArgs Wea)
{
 SCROLLINFO si;

 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("Entering frmOutput_OnVScroll()\n"));
 #endif
 si.nPos=(int)GetWindowLong(Wea->hWnd,12);
 switch(LOWORD(Wea->wParam))
 {
  case SB_LINEUP:
    if(si.nPos)
    {
       si.cbSize = sizeof(SCROLLINFO);
       si.nPos--;
       SetWindowLong(Wea->hWnd,12,(long)si.nPos);
       si.fMask = SIF_POS;
       SetScrollInfo(Wea->hWnd,SB_VERT,&si,TRUE);
       ScrollWindow(Wea->hWnd,0,GetWindowLong(Wea->hWnd,8),0,0);
    }
    break;
  case SB_PAGEUP:
    {
       unsigned int iLinesVisible;
       RECT rc;
       GetClientRect(Wea->hWnd,&rc);
       iLinesVisible=rc.bottom/GetWindowLong(Wea->hWnd,8);
       si.cbSize = sizeof(SCROLLINFO);
       si.nPos=si.nPos-iLinesVisible;
       if(si.nPos<0)
          si.nPos=0;
       SetWindowLong(Wea->hWnd,12,(long)si.nPos);
       si.fMask = SIF_POS;
       SetScrollInfo(Wea->hWnd,SB_VERT,&si,TRUE);
       ScrollWindow(Wea->hWnd,0,rc.bottom,0,0);
    }
    break;
  case SB_LINEDOWN:
    si.cbSize =sizeof(SCROLLINFO);
    si.fMask = SIF_POS | SIF_RANGE;
    GetScrollInfo(Wea->hWnd,SB_VERT,&si);
    if(si.nPos<si.nMax)
    {
       si.nPos++;
       SetWindowLong(Wea->hWnd,12,(long)si.nPos);
       si.fMask = SIF_POS;
       SetScrollInfo(Wea->hWnd,SB_VERT,&si,TRUE);
       ScrollWindow(Wea->hWnd,0,-GetWindowLong(Wea->hWnd,8),0,0);
    }
    break;
  case SB_PAGEDOWN:
    {
       unsigned int iLinesVisible;
       RECT rc;

       si.cbSize =sizeof(SCROLLINFO);
       si.fMask = SIF_POS | SIF_RANGE;
       GetScrollInfo(Wea->hWnd,SB_VERT,&si);
       GetClientRect(Wea->hWnd,&rc);
       iLinesVisible=rc.bottom/GetWindowLong(Wea->hWnd,8);
       if(int(iLinesVisible+si.nPos)<=si.nMax)
          si.nPos = si.nPos + iLinesVisible;
       else
          si.nPos=si.nMax;
       SetWindowLong(Wea->hWnd,12,(long)si.nPos);
       si.fMask = SIF_POS;
       SetScrollInfo(Wea->hWnd,SB_VERT,&si,TRUE);
       ScrollWindow(Wea->hWnd,0,rc.bottom,0,0);
    }
    break;
 }
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("Leaving frmOutput_OnVScroll()\n\n"));
 #endif

 return 0;
}


long frmOutput_OnPaint(lpWndEventArgs Wea)
{
 unsigned int iLineCount,i,iStart,iFinish,iLine,iPos;
 TCHAR** ptrPtrBuffer=NULL;
 HFONT hFont,hTmp;
 PAINTSTRUCT ps;
 long cyChar;
 HDC hDC;

 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("Entering frmOutput_OnPaint()\n"));
 #endif
 iLineCount=(unsigned int)GetWindowLong(Wea->hWnd,0);  //How Many Lines In Scroll Buffer?
 ptrPtrBuffer=(TCHAR**)GetWindowLong(Wea->hWnd,4);     //Buffer Holding String Pointers
 cyChar=GetWindowLong(Wea->hWnd,8);                    //How High Is Each Line?
 iPos=GetWindowLong(Wea->hWnd,12);                     //What's The Top Line Number?

 hDC=BeginPaint(Wea->hWnd,&ps);                        //Need A Device Context To Print In Windows!
 iStart=ps.rcPaint.top/cyChar;                         //Gotta Find Bounds Of Invalid Region In
 iFinish=ps.rcPaint.bottom/cyChar;                     //Terms Of Top & Bottom.
 hFont=CreateFont(16,0,0,0,FW_BOLD,0,0,0,0,0,0,2,0,_T("Courier New"));
 hTmp=(HFONT)SelectObject(hDC,hFont);
 SetBkMode(hDC,TRANSPARENT);
 for(i=iStart;i<=iFinish;i++)
 {
     iLine=iPos+i;
     if(iLine<iLineCount)
     {
        if(ptrPtrBuffer[iLine])
           TextOut(hDC,0,i*cyChar,ptrPtrBuffer[iLine],_tcslen(ptrPtrBuffer[iLine]));
     }
 }
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("  iLineCount      = %u\n"),iLineCount);
     _ftprintf(fp,_T("  ptrPtrBuffer    = %u\n"),ptrPtrBuffer);
     _ftprintf(fp,_T("  cyChar          = %u\n"),cyChar);
     _ftprintf(fp,_T("  iPos            = %u\n"),iPos);
 #endif
 DeleteObject(SelectObject(hDC,hTmp));
 EndPaint(Wea->hWnd,&ps);
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("Leaving frmOutput_OnPaint()\n\n"));
 #endif

 return 0;
}


long frmOutput_OnClose(lpWndEventArgs Wea)                    //The logic this app uses to display the database data
{                                                             //is a bit on the complex side.  First, in all the procedures
 unsigned int blnFree=0,iLineCount;                           //that generate output, an estimate is made of the maximum
 TCHAR** ptrPtrBuffer=0;                                      //number of lines that will be needed to display the data.
 unsigned int i;                                              //A memory allocation is then made for TCHAR** pointers of
                                                              //a number equal to this maximum number of lines.  The bytes
 #if defined(MY_DEBUG)                                        //needed for this TCHAR** buffer to contain a TCHAR* for each
     _ftprintf(fp,_T("Entering frmOutput_OnClose()\n"));      //line would be the sizeof(TCHAR*) times the number of lines
 #endif                                                       //needed.  Back in those routines the obtained pointer to the
 iLineCount=(unsigned int)GetWindowLong(Wea->hWnd,0);         //memory is stored at offset 4 in frmOutput's .cbWndExtra bytes.
 ptrPtrBuffer=(TCHAR**)GetWindowLong(Wea->hWnd,4);            //The number of lines is stored at offset zero.  Back within
 #if defined(MY_DEBUG)                                        //those various routines that generate output, another memory
     _ftprintf(fp,_T("  ptrPtrBuffer = %u\n"),ptrPtrBuffer);  //allocation has to be made for each line's characters, and the
 #endif                                                       //address of that line's memory allocation has to be stored in
 if(ptrPtrBuffer)                                             //the proper slot in the TCHAR** buffer.  So, when any instance
 {                                                            //of frmOutput is destroyed, frmOutput_OnClose() has to clean
    for(i=0;i<iLineCount;i++)                                 //up, i.e., deallocate, the memory for each line of text, and
    {                                                         //when all the lines of text have been deallocated, finally
        if(ptrPtrBuffer[i])                                   //deallocate the main memory buffer where all the TCHAR* have
        {                                                     //been stored, i.e., the TCHAR** buffer whose address is stored
           blnFree=(unsigned int)GlobalFree(ptrPtrBuffer[i]); //in offset bytes 4 - 7.
           #if defined(MY_DEBUG)
               _ftprintf(fp,_T("  %u\t%u\n"),i,blnFree);
           #endif
        }
        else
        {
           #if defined(MY_DEBUG)
               _ftprintf(fp,_T("  %u\tN.A.\n"),i);
           #endif
        }
    }
    blnFree=(unsigned int)GlobalFree(ptrPtrBuffer);
    #if defined(MY_DEBUG)
        _ftprintf(fp,_T("\n  GlobalFree(ptrPtrBuffer) = %u\n"),blnFree);
    #endif
 }
 DestroyWindow(Wea->hWnd);
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("Leaving frmOutput_OnClose()\n\n"));
 #endif

 return 0;
}


long __stdcall frmOutput(HWND hwnd, unsigned int msg, WPARAM wParam,LPARAM lParam)
{
 WndEventArgs Wea;                                           //Most folks who do Sdk style
                                                             //Windows Api coding probable
 for(unsigned int i=0;i<5 ;i++)                              //use a switch construct to map
 {                                                           //messages to procedures to
     if(frmOutputHdlr[i].Code==msg)                          //handle them, but I prefer to
     {                                                       //do this mapping with a for
        Wea.hWnd=hwnd,Wea.lParam=lParam,Wea.wParam=wParam;   //loop.  It produces the smallest
        return (*frmOutputHdlr[i].fnPtr)(&Wea);              //possible Window Procedure.  It
     }                                                       //requires though my
 }                                                           //AttachMessageHandlers() routine,
                                                             //and a struct to associate message
 return (DefWindowProc(hwnd,msg,wParam,lParam));             //handling function pointers with
}                                                            //the message to be handled.
